<template>
  <q-layout view="lHh Lpr lFf">
    <q-drawer v-model="leftDrawerOpen" bordered class="custom-drawer" overlay>
      <q-list>
        <q-item clickable @click="toggleExpand">
          <q-item-section v-if="dropDownItem.icon" avatar>
            <q-icon :name="dropDownItem.icon" />
          </q-item-section>

          <q-item-section>
            <q-item-label>{{ dropDownItem.title }}</q-item-label>
          </q-item-section>

          <q-item-section side top>
            <q-icon name="expand_more" :class="{ 'item-rotate': isExpanded }" />
          </q-item-section>
        </q-item>

        <div v-if="isExpanded" class="submenu">
          <EssentialLink v-for="link in sublinksList" :key="link.title" v-bind="link" class="q-ml-md" />
        </div>

        <EssentialLink v-for="link in linksList" :key="link.title" v-bind="link" />
      </q-list>
    </q-drawer>
    <q-header reveal class="row no-wrap items-center navbar q-px-lg q-py-sm">
      <q-btn flat dense round class="menu-btn" icon="menu" aria-label="Menu" @click="toggleLeftDrawer" />
      <q-img :src="logoUrl" class="navbar-icon" @click="router.push('/')" />

      <q-space />
      <q-select v-if="projectOptions.length > 0 && access" filled bg-color="transparent" color="black"
        class="select-project" v-model="selectedProject" :options="projectOptions"
        @update:model-value="updateProject"></q-select>

      <!-- Show User Icon or Login based on user status -->
      <q-btn v-if="access" flat dense no-caps padding="0" class="user-menu" :icon="userIcon" label="" no-arrow
        color="black">
        <q-menu>
          <q-item clickable @click="logout">
            <q-item-section avatar>
              <q-icon name="logout" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Logout</q-item-label>
            </q-item-section>
          </q-item>
          <q-item clickable @click="changePassword">
            <q-item-section avatar>
              <q-icon name="lock" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Change Password</q-item-label>
            </q-item-section>
          </q-item>
          <q-item clickable @click="deleteAccount">
            <q-item-section avatar>
              <q-icon name="delete" />
            </q-item-section>
            <q-item-section>
              <q-item-label>Delete Account</q-item-label>
            </q-item-section>
          </q-item>
        </q-menu>
      </q-btn>
      <q-btn v-else to="/login" no-caps padding="14px 36px" class="login-btn" color="white" text-color="black" flat>
        Login
      </q-btn>
    </q-header>


    <q-page-container>
      <BreadCrumbs v-if="!$route.meta.hideBreadcrumbs" />

      <router-view />
    </q-page-container>
  </q-layout>
</template>

<script setup lang="ts">
import { ref, computed, onMounted, watchEffect, watch } from 'vue';
import { useRouter } from 'vue-router';
import { useStore } from 'vuex';
import BreadCrumbs from 'src/components/BreadCrumbs.vue';
import EssentialLink from 'src/components/EssentialLink.vue';
import { useProjects } from 'src/hooks/projects';
import { nextTick } from 'vue';
import logoUrl from 'assets/nephele_logo.png';

const store = useStore();
const router = useRouter();
const leftDrawerOpen = ref(false);
const isExpanded = ref(false);
const { projects, fetchProjects } = useProjects();
const access = computed(
  () =>
    store.getters.accessToken !== '' && store.getters.accessToken !== undefined,
);
// const projectName = computed(() => store.getters.projectName);
// const projectsArray = computed(() => projects.value.groups.map(group => ({ label: group.name, value: group.id })));

const selectedProject = ref(null);

watch(
  () => router.getRoutes,
  async (newPath, oldPath) => {
    if (newPath !== oldPath) {
      await fetchProjects();
      await nextTick();
      selectedProject.value = store.getters.projectName;
      await nextTick();

      if (projects.value?.groups.length === 0 && access.value) {
        router.push('/create_project');
      } else if (projects.value?.groups.length === 0 && !access.value) {
        router.push('/login');
      }
    }
  },
);

onMounted(async () => {
  await fetchProjects();
  await nextTick();
  selectedProject.value = store.getters.projectName;

  if (projects.value?.groups.length === 0 && access.value) {
    router.push('/create_project');
  } else if (projects.value?.groups.length === 0 && !access.value) {
    router.push('/login');
  }
});
watchEffect(() => {
  if (projects.value?.groups && projects.value.groups.length > 0) {
    const currentProjectName = store.getters.projectName;
    const projectExists = projects.value.groups.some(
      (project) => project.name === currentProjectName,
    );
    selectedProject.value = projectExists
      ? currentProjectName
      : projects.value.groups[0].name;
  } else {
    selectedProject.value = null;
  }
  if (!access.value) {
    logout();
  }
});
watch(
  () => store.getters.projectName,
  (newName) => {
    selectedProject.value = newName;
  },
);

const updateProject = (newProjectName: object) => {
  if (newProjectName.value === '__CREATE_NEW_PROJECT__' || newProjectName.value === null) {
    router.push('/create_project');
  } else {
    store.commit('setProjectName', newProjectName.value);
  }
};
const userIcon = computed(() => 'account_circle');

function changePassword() {
  router.push('/change_password');
}

function deleteAccount() {
  router.push('/delete_account');
}


const projectOptions = computed(() => {
  const options = projects.value.groups.map((project) => ({
    label: project.name,
    value: project.name,
  }));
  options.push({
    label: 'Create New Project',
    value: '__CREATE_NEW_PROJECT__',
  });

  return options;
});

watch(
  () => router.currentRoute.value,
  (to, from) => {
    if (from.path === '/create_project' || from.path === '/login') {
      fetchProjects(); // Fetch projects after creating a new project
    }
  },
);
function toggleLeftDrawer() {
  leftDrawerOpen.value = !leftDrawerOpen.value;
}

function toggleExpand() {
  isExpanded.value = !isExpanded.value;
}

// Links data
const linksList = ref([
  {
    title: 'Development Environment',
    icon: 'language',
    link: '/development_environment',
  },
  { title: 'Infrastructure', icon: 'code', link: '/infrastructure' },
  { title: 'Operations', icon: 'table_chart', link: '/operations' },
]);

const dropDownItem = {
  title: 'Software artifacts',
  icon: 'record_voice_over',
  link: '',
};
const sublinksList = ref([
  {
    title: 'Virtual Objects',
    icon: 'record_voice_over',
    link: '/software_artifacts/virtual_objects',
  },
  {
    title: 'Composite Virtual Objects',
    icon: 'language',
    link: '/software_artifacts/composite_virtual_objects',
  },
  {
    title: 'Application Component',
    icon: 'code',
    link: '/software_artifacts/application_component',
  },
  {
    title: 'Application Graph',
    icon: 'table_chart',
    link: '/software_artifacts/application_graph',
  },
]);

function logout() {
  store.commit('logout');
  router.push('/login');
}
</script>

<style lang="scss">
.navbar {
  background: rgba(255, 255, 255, 0.1);
  border-bottom: 2px solid rgba(255, 255, 255, 0.2);
  backdrop-filter: blur(10px);
  z-index: 2;
}

.navbar-icon {
  cursor: pointer;
  width: 8rem;
  margin-right: 8px;
}

.menu-btn {
  color: lightgrey;
  margin-right: 10px;
}

.q-drawer-container {
  position: absolute;
  z-index: 1;
}

.custom-drawer {
  position: absolute;
  top: 51px;
  height: calc(100% - 56px);
  z-index: 1;
  background-color: rgba(255, 255, 255, 0.1);
  padding-top: 25px;
  border-top: none;
}

.login-btn {
  border-radius: 20px;
  box-shadow: none;
  color: black;
  border: 1px solid #d9cccc;
}

.projectName {
  font-size: 1rem;
  font-weight: 500;
  color: black;
}

.select-project {
  margin-right: 20px;
}

.user-menu {
  .q-btn__content {
    display: flex;
    align-items: center;
    justify-content: center;
  }

  .q-icon {
    font-size: 1.5rem;
  }
}
</style>
